<script lang="ts" setup name="ListPlan">
import { getCurrentInstance, ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IOptions, IPlanList, lPlanistQuery } from './plan_interface'
import QrDialog from '@/components/QrDialog/index.vue'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { exportPlanList, getDeptTree, getListDelete, getPlanList } from '@/api/measure/plan'
import { printJSON } from '@/utils/printUtils'
import { SCHEDULE } from '@/utils/scheduleDict'
import { exportFile } from '@/utils/exportUtils'
const listQuery = ref<lPlanistQuery>({
  createEndTime: '', // 创建结束时间
  createStartTime: '', // 创建开始时间
  deptId: '', // 部门id
  director: '', // 负责人
  effectiveCompany: '', // 实施单位
  ids: [], // 导出数组
  trainEndTime: '', // 培训结束时间
  formId: SCHEDULE.TRAIN_APPROVAL, // 表单id
  trainStartTime: '', // 培训开始时间
  offset: 1, // 当前页
  limit: 20, // 每页多少条
})
const checkoutList = ref<string[]>([])
const list = ref<IPlanList[]>([])
const total = ref(0)
// 主管部门下拉框
const options = ref<IOptions[]>([])
const loadingTable = ref(false)
// 初始化路由
// 培训时间数组
const trainTime = ref('')
// 创建时间数组
const createTime = ref('')
const $router = useRouter()

// 获取数据
const fetchData = (isNowPage: boolean) => {
  listQuery.value.trainStartTime = trainTime.value[0] || ''
  listQuery.value.trainEndTime = trainTime.value[1] || ''
  listQuery.value.createStartTime = createTime.value[0] || ''
  listQuery.value.createEndTime = createTime.value[0] || ''
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getPlanList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
fetchData(true)
const { proxy } = getCurrentInstance() as any
// 表头
const columns = ref<TableColumn[]>([
  { text: '计划编号', value: 'planNo', width: '160', align: 'center' },
  { text: '培训名称', value: 'planName', align: 'center' },
  { text: '培训对象', value: 'trainPerson', align: 'center' },
  { text: '培训人数', value: 'trainNumber', align: 'center' },
  { text: '培训学时', value: 'trainHour', align: 'center' },
  { text: '培训时间', value: 'trainTime', width: '180', align: 'center' },
  { text: '主管部门', value: 'deptName', align: 'center' },
  { text: '实施单位', value: 'effectiveCompany', align: 'center' },
  { text: '负责人', value: 'director', align: 'center' },
  { text: '培训内容', value: 'trainContent', align: 'center' },
  { text: '创建时间', value: 'createTime', width: '180', align: 'center' },
  { text: '备注', value: 'remark', align: 'center' },
])
// 搜索
const searchList = () => {
  fetchData(true)
}

// 重置
const clearList = () => {
  listQuery.value = {
    createEndTime: '', // 创建结束时间
    createStartTime: '', // 创建开始时间
    deptId: '', // 部门id
    director: '', // 负责人
    effectiveCompany: '', // 实施单位
    ids: [], // 导出数组
    trainEndTime: '', // 培训结束时间
    formId: SCHEDULE.TRAIN_APPROVAL, // 表单id
    trainStartTime: '', // 培训开始时间
    offset: 1, // 当前页
    limit: 20, // 每页多少条
  }
  trainTime.value = ''
  createTime.value = ''
  fetchData(true)
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    listQuery.value.ids = checkoutList.value
    exportPlanList(listQuery.value).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '培训计划列表.xlsx')
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  loading.close()
}
// 点击编辑id和删除row类型
interface rowReturn {
  id: string
  planName: string
}
// 点击编辑/详情
const handleEdit = (row: rowReturn, pageType: 'edit' | 'detail') => {
  $router.push(`/train/${pageType}/${row.id}`)
}
// 点击删除
const handleDelete = (index: string, row: rowReturn) => {
  ElMessageBox.confirm(
    `确认删除${row.planName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      getListDelete({ id: row.id as string }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          fetchData(true)
        }
      })
    })
}
// 多选框选择数据
const handleSelectionChange = (e: any) => {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}
// 点击新增
const add = () => {
  $router.push('/train/add')
}
// 导出
const exportAll = () => {
  exportExcelBtn()
}
// 获取到组织信息
const getDept = () => {
  const params = {
    roleId: '',
    deptType: '',
    tips: '',
  }
  getDeptTree(params).then((response) => {
    options.value = response.data
  })
}
getDept()
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}
// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '培训计划列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: IPlanList) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '培训计划列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}
const qrDialog = ref()
// 点击二维码
const qrDialogShow = (row: rowReturn) => {
  qrDialog.value.initDialog(row.id, row.planName)
}
</script>

<template>
  <app-container>
    <search-area :need-clear="true" @search="searchList" @clear="clearList">
      <search-item>
        <el-date-picker
          v-model="trainTime"
          type="datetimerange"
          range-separator="到"
          format="YYYY-MM-DD HH:mm:ss"
          value-format="YYYY-MM-DD HH:mm:ss"
          start-placeholder="培训时间开始时间"
          end-placeholder="培训时间结束时间"
        />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="createTime"
          type="datetimerange"
          range-separator="到"
          format="YYYY-MM-DD HH:mm:ss"
          value-format="YYYY-MM-DD HH:mm:ss"
          start-placeholder="创建时间开始时间"
          end-placeholder="创建时间结束时间"
        />
      </search-item>
      <search-item>
        <dept-select
          ref="deptSelect"
          v-model="listQuery.deptId"
          placeholder="请选择主管部门"
          :dept-show="true"
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.effectiveCompany"
          placeholder="实施单位"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.director"
          placeholder="负责人"
          clearable
        />
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button
          v-if="proxy.hasPerm('/measure/train/plan/add')"
          icon="icon-add"
          title="新建"
          type="primary"
          @click="add"
        />
        <icon-button
          v-if="proxy.hasPerm('/measure/train/plan/export')"
          icon="icon-export"
          title="导出"
          type="primary"
          @click="exportAll"
        />
        <icon-button
          v-if="proxy.hasPerm('/measure/train/plan/print')"
          icon="icon-print"
          title="打印"
          type="primary"
          @click="printList"
        />
      </template>
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        :list-loading="loadingTable"
        is-showmulti-select
        @change="changePage"
        @multiSelect="handleSelectionChange"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" width="170" fixed="right">
            <template #default="{ row }">
              <!-- <el-button
                v-if="proxy.hasPerm('/measure/train/plan/edit')"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'edit')"
              >
                编辑
              </el-button> -->
              <el-button
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'detail')"
              >
                详情
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/measure/train/plan/delete')"
                size="small"
                link
                type="danger"
                @click="handleDelete(row.$index, row)"
              >
                删除
              </el-button>
              <el-button
                size="small"
                link
                type="primary"
                @click="qrDialogShow(row)"
              >
                二维码
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
  <qr-dialog ref="qrDialog" />
</template>
